**RNLIB***********************************
******************************************
**                                      **
** Name: ReNameLib                      **
**                                      **
** Stack: (LIB $ ---> LIB')             **
**                                      **
** Calls: PopASavptr GETTEMP GETPTRLOOP **
**        GPOverWrR0Lp                  **
**                                      **
** Regs:                                **
**      R0-> new lib                    **
**      R1-> Old Lib                    **
**      R2-> $                          **
**      R3-> Size $                     **
**                                      **
** Written: 2.11.94      Will Laughlin  **
**                                      **
** Version: 1.0                         **
**                                      **
******************************************
******************************************
::
 CK2NOLASTWD
 CK&DISPATCH2
 #8F3
  ::
     SWAP CHKREF SWAP
CODE
	ST=0    1
	GOSBVL  =PopASavptr
	R2=A
	C=DAT1  A
	R1=C
	D0=C
	D1=A
	GOSBVL  =GetStrLen
	R3=C
	D0=D0+  5
	A=DAT0  A       * Get size of lib
	B=A     A
	D0=D0+  5
	A=0     A
	A=DAT0  B       * Get size of title
	?A=0    A
	GOYES   libNull
	?A=C    A
	GOYES   SameSize
	A=A+A   A
	A=B-A   A       * Sub form total size
	GONC    test$
*****************************************
libNull
	ST=1    1
	A=A+CON A,2
	A=A+B   A       
test$
	?C=0    A
	GOYES   $NULL
	C=C+C   A
	C=A+C   A
	GONC    GetMem
*****************************************
Exit
	GOVLNG  =GETPTRLOOP
SameSize
	C=C+C   A
	AD0EX
	AD1EX
	D0=A
	D1=D1+  2
	GOSBVL  =MOVEDOWN
	A=R1
	R0=A
	GOTO    End
*****************************************
$NULL
	?ST=1   1
	GOYES   Exit
	A=A-CON A,2
	C=A+C   A
GetMem
	RSTK=C
	C=C+CON A,5     * alloc mem
	GOSBVL  =GETTEMP
	AD0EX
	R0=A
	D1=A
	A=R2
	D0=A
	D0=D0+  10      
	LC(5)   =DOLIB  * write prolog
	DAT1=C  A
	D1=D1+  5
	C=RSTK
	DAT1=C  A       * write size
	D1=D1+  5
	C=R3
	DAT1=C  B       * write title size
	D1=D1+  2
	C=C+C   A       * Copy in new title
	GOSBVL  =MOVEDOWN
	C=R3
	?C=0    A       * If name null skip second size field
	GOYES   CPlib
	DAT1=C  B
	D1=D1+  2
CPlib
	A=R1
	A=A+CON A,5
	D0=A
	B=A     A       * save ptr to lib size
	C=DAT0  A
	D=C     A
	D0=D0+  5
	A=0     A
	A=DAT0  B       * get title size
	?A=0    A       * if 0 skip to LID
	GOYES   skp2
	A=A+A   A       * skip over title
	CD0EX
	C=A+C   A
	CD0EX
	D0=D0+  2
skp2
	D0=D0+  2       * D0-> LID
	CD0EX
	D0=C
	A=B     A
	C=C-A   A       * compute # nibs to LID
	CDEX    A
	C=C-D   A       * sub from total size
	GOSBVL  =MOVEDOWN * Copy rest of LIB
	A=R0
End
	D0=A
	D0=D0+  5
	A=DAT0  A
	A=A-CON A,4
	GOSBVL  =DoCRC
	DAT0=A  4       * Write new crc
	GOVLNG  =GPOverWrR0Lp
ENDCODE
 ;
;



