********************************************************************
* Name:  Strip
*
* Stack:  Anything, does arg checking for a program
* 
* Description:  Strips the user-rpl delimiters "x<<" and "x>>" off of a 
*               user-rpl program.
*
* Registers:  A, C, R0, R3 and R4
*
* Written:    6/25/94               Will Laughlin
*             2/2/95                Will Laughlin       rewritten
*********************************************************************

RPL
 ::
 CK1NOLASTWD
 CODE
        GOSBVL   =SAVPTR
        C=DAT1   A
        RSTK=C
        D0=C
        A=DAT0  A
        LC(5)   =DOCOL
        ?C=A    A        *Test for a program
        GOYES   COL
        GONC    Exit     *If not just exit
COL    
        D0=D0+  5
        A=DAT0  A
        LC(5)   =x<<
        ?C=A    A        *Test for u-rpl delimiter
        GOYES   STRIP
        GONC    Exit     *If exists strip else exit
STRIP   
        D0=D0-  5
        GOSBVL  =SKIPOB
        AD0EX
        C=RSTK
        RSTK=C
        C=A-C   A
        C=C-CON A,10
        GOSBVL  =GETTEMP *Allocate mem for new program
        D=C      A
        AD0EX
        D1=A
        B=A      A
        C=RSTK
        D0=C
        D0=D0+  10
        LC(5)   =DOCOL   *Write prologue
        DAT1=C  A
        D1=D1+  5
        C=D     A
        C=C-CON A,10
        GOSBVL  =MOVEDOWN *Copy remaining part of the orgional program
        LC(5)   =SEMI
        DAT1=C  A
        A=B      A
        GOVLNG  =GPOverWrALp
Exit   
        GOVLNG  =GETPTRLOOP
ENDCODE
;
