
proc(mp,x,p)
local mpoly,d,d1,uu,i,u,lu,a,k,j,t,q,c,r,mi,jj,kk,f,rr,tk,tkj,ff,anz;
options `Copyright 1993 by Waterloo Maple Software`;
    mpoly := mods(mp,p);
    userinfo(2,factor,`the arguments are:`,args);
    d := degree(mpoly,x);
    if d <= 1 then f[0] := d; f[1] := mpoly; RETURN(op(f)) fi;
    d1 := d-1;
    lu := lcoeff(mpoly,x);
    if lu <> 1 then uu := mods(mods(1/lu,p)*mpoly,p) else uu := mpoly fi;
    for i from 0 to d do  u[i] := mods(coeff(uu,x,i),p) od;
    a[0] := 1;
    for i to d1 do  a[i] := 0 od;
    for k to d1 do
        for j to p do
            t := a[d1];
            for i from d1 by -1 to 1 do  a[i] := mods(a[i-1]-t*u[i],p) od;
            a[0] := mods(-t*u[0],p)
        od;
        for j from 0 to d1 do  q[k,j] := a[j] od;
        q[k,k] := mods(q[k,k]-1,p)
    od;
    userinfo(2,factor,`Q matrix formed`);
    for i from 0 to d1 do  c[i] := -1 od;
    r := 0;
    for k to d1 do
        for j from 0 to d1 while q[k,j] = 0 or 0 <= c[j] do   od;
        if j < d then
            mi := mods(-1/q[k,j],p);
            q[k,j] := -1;
            if mi <> 1 then
                for i from k+1 to d1 do  q[i,j] := mods(mi*q[i,j],p) od
            fi;
            for jj from 0 to d1 do
                if jj <> j and q[k,jj] <> 0 then
                    mi := q[k,jj];
                    q[k,jj] := 0;
                    for i from k+1 to d1 do
                        q[i,jj] := mods(q[i,jj]+mi*q[i,j],p)
                    od
                fi
            od;
            c[j] := k
        else
            r := r+1;
            for i from 0 to d1 do  q[r,i] := 0 od;
            for i from 0 to d1 do
                if 0 <= c[i] then q[r,c[i]] := q[k,i] fi
            od;
            q[r,k] := 1
        fi
    od;
    userinfo(2,factor,`null space found`,lprint(`the number of factors is`,r+1)
        );
    if r = 0 then f[0] := 1; f[1] := mpoly; RETURN(op(f)) fi;
    f[1] := convert([u[kk]*x^kk $ (kk = 0 .. d1),x^d],`+`);
    rr := 1;
    for k to r while rr <= r do
        i := 'i';
        tk := convert([q[k,i]*x^i $ (i = 0 .. d1)],`+`);
        for j from 0 to p-2 while rr <= r do
            tkj := tk-j;
            anz := rr;
            for i to anz while rr <= r do
                ff := modp(Gcd(tkj,f[i]),p);
                if ff <> 1 and degree(ff,x) < degree(f[i],x) then
                    rr := rr+1; f[rr] := modp(Quo(f[i],ff,x),p); f[i] := ff
                fi
            od
        od
    od;
    i := 'i';
    f[0] := rr;
    f[1] := mods(lu*f[1],p);
    userinfo(2,factor,`modular factors found`,
        lprint(`the modular factors are`,f[i] $ (i = 1 .. rr)));
    op(f)
end

