**********************************************************************
* Desc:		Calculate integer factorial
* Stack:	( # --> Z )
* Notes:	Using the recursive algorithm makes a very big
*		difference in speed for large N.
**********************************************************************
NULLNAME Z!
::
  DUP#0=csedrp HXS 2 10			( 0! = 1 )
  ONESWAP				( low hi )
  LABEL Recurse!
  ::
    2DUP#= casedrop #>Z			( a b --> Z )
    2DUP#+ #2/				( a b [a+b]/2 )
    DUP#1+ 4ROLLSWAP			( b [a+b]/2 a [a+b]/2+1 )
    CODE
-	A=PC
	LC(5)	(Recurse!)-(*)
	A=A+C	A
	PC=(A)
    ENDCODE				( b [a+b]/2 Z1 )
    UNROTSWAP				( Z1 [a+b]/2 b )
    CODE
	GOTO	-
    ENDCODE				( Z1 Z2 )
    QMul
  ;
;
**********************************************************************
