
**********************************************************************
*		Library Specifics
**********************************************************************

** ROMID

xROMID 390 ( 912 )
ASSEMBLE
=LONGROMID	EQU #390
RPL

** CONFIG

ASSEMBLE
=LONGcfg
RPL
:: [#] LONGROMID TOSRRP ;

** MESSAGES
ASSEMBLE
=LONGmsg
RPL

** EXTERNALS

EXTERNAL xFADD
EXTERNAL xFSUB
EXTERNAL xFMUL
EXTERNAL xFDIV
EXTERNAL xFINV
EXTERNAL xFNEG
EXTERNAL xFSQRT
EXTERNAL xFPOW
EXTERNAL xFPI
EXTERNAL xFEXP
EXTERNAL xFLN
EXTERNAL xFCMP
EXTERNAL xFSIN
EXTERNAL xFCOS
EXTERNAL xFTAN
EXTERNAL xFASIN
EXTERNAL xFACOS
EXTERNAL xFATAN
EXTERNAL xFSINH
EXTERNAL xFCOSH
EXTERNAL xFTANH
EXTERNAL xFASINH
EXTERNAL xFACOSH
EXTERNAL xFATANH
EXTERNAL xFIP
EXTERNAL xFFP

EXTERNAL Inf1:
EXTERNAL Inf2:

EXTERNAL DigitsBind
EXTERNAL Digits
EXTERNAL Digits+
EXTERNAL Digits-

EXTERNAL Normalize

EXTERNAL Str2Inf2
EXTERNAL Str2Inf
EXTERNAL Inf2Str

EXTERNAL InfAdd
EXTERNAL InfSub
EXTERNAL InfMul
EXTERNAL InfDiv
EXTERNAL InfInv
EXTERNAL InfNeg
EXTERNAL InfSqrt
EXTERNAL InfPow
EXTERNAL InfPi
EXTERNAL InfExp
EXTERNAL InfLn
EXTERNAL InfSin
EXTERNAL InfCos
EXTERNAL InfTan
EXTERNAL TrigSerie
EXTERNAL TrigNorm
EXTERNAL InfASin
EXTERNAL InfACos
EXTERNAL InfATan
EXTERNAL InfSinh
EXTERNAL InfCosh
EXTERNAL InfTanh
EXTERNAL InfASinh
EXTERNAL InfACosh
EXTERNAL InfATanh
EXTERNAL InfCmp
EXTERNAL InfIp
EXTERNAL InfFp

EXTERNAL ZPowZ
EXTERNAL InfPowZ


**********************************************************************
*		Unsupported Entries
**********************************************************************


**********************************************************************
*		Programs
**********************************************************************


	STITLE	ALG Long Float
**********************************************************************
*	ALG library: Long Floating Point Math
**********************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME FADD
::
  CK2&Dispatch
  strstr :: Inf2: InfAdd ;
;

**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME FSUB
::
  CK2&Dispatch
  strstr :: Inf2: InfSub ;
;
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME FMUL
::
  CK2&Dispatch
  strstr :: Inf2: InfMul ;
;
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME FDIV
::
  CK2&Dispatch
  strstr :: Inf2: InfDiv ;
;
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME FINV
::
  CK1&Dispatch
  str :: Inf1: InfInv ;
;
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME FNEG
::
  CK1&Dispatch
  str :: Inf1: InfNeg ;
;
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME FSQRT
::
  CK1&Dispatch
  str :: Inf1: InfSqrt ;
;

**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME FPOW
::
  CK2&Dispatch
  strstr :: Inf2: InfPow ;
;
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME FPI
::
  CK0
  FastLib
  DigitsBind InfPi Inf2Str ABND
;
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME FEXP
::
  CK1&Dispatch
  str :: Inf1: InfExp ;
;

**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME FLN
::
  CK1&Dispatch
  str :: Inf1: InfLn ;
;
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME FCMP
::
  CK2&Dispatch
  strstr :: FastLib
	    Str2Inf2 DigitsBind InfCmp
	    #1+ UNCOERCE %1-
	    ABND
	 ;
;

**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME FSIN
::
  CK1&Dispatch
  str :: Inf1: InfSin ;
;

**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME FCOS
::
  CK1&Dispatch
  str :: Inf1: InfCos ;
;

**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME FTAN
::
  CK1&Dispatch
  str :: Inf1: InfTan ;
;
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME FASIN
::
  CK1&Dispatch
  str :: Inf1: InfASin ;
;

**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME FACOS
::
  CK1&Dispatch
  str :: Inf1: InfACos ;
;

**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME FATAN
::
  CK1&Dispatch
  str :: Inf1: InfATan ;
;
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME FSINH
::
  CK1&Dispatch
  str :: Inf1: InfSinh ;
;

**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME FCOSH
::
  CK1&Dispatch
  str :: Inf1: InfCosh ;
;

**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME FTANH
::
  CK1&Dispatch
  str :: Inf1: InfTanh ;
;
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME FASINH
::
  CK1&Dispatch
  str :: Inf1: InfASinh ;
;

**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME FACOSH
::
  CK1&Dispatch
  str :: Inf1: InfACosh ;
;

**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME FATANH
::
  CK1&Dispatch
  str :: Inf1: InfATanh ;
;

**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME FIP
::
  CK1&Dispatch
  str :: Inf1: InfIp ;
;

**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME FFP
::
  CK1&Dispatch
  str :: Inf1: InfFp ;
;

**********************************************************************
*		DISPATCH SUBROUTINES
**********************************************************************

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Name:		Inf1:
* Stack:	( $inf --> $inf' )
* Desc:		Evaluate unary function from previous stream
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
NULLNAME Inf1:
::
  'RRDROP			( $inf cmd )
  FastLib
  SWAP Str2Inf			( cmd Zm Ze )
  DigitsBind			
  ROT EVAL			( Zm' Ze' )
  Inf2Str ABND			( $inf' )
;
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Name:		Inf2:
* Stack:	( $inf1 $inf2 --> $inf )
* Desc:		Evaluate binary function from previous stream
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
NULLNAME Inf2:
::
  'RRDROP			( $inf1 $inf2 cmd )
  FastLib
  UNROT Str2Inf2		( cmd Zm1 Ze1 Zm2 Ze2 )
  DigitsBind
  5ROLL EVAL			( Zm' Ze' )
  Inf2Str ABND			( $inf )
;

**********************************************************************
*		DIGITS DEFINITIONS
**********************************************************************

* D is the current precision as a system binary
* DZ is the base precision 10^D used throughout in normalization etc

DEFINE DZ	2GETLAM
DEFINE DZ!	2PUTLAM
DEFINE D	1GETLAM
DEFINE D!	1PUTLAM

* The following constants are used when calculating approximations
* for how many digits a given number will take in decimal form.
*
*	Digits ~= Log2*bits(mantissa)
*	Digits ~= Log2*nibbles(mantissa)

DEFINE Log2	% .301029995664
DEFINE Log16	% 1.20411998266

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Name:		DigitsBind
* Stack:	( --> )
* Desc:		Search for current user defined precision
*		and bind the associated local variables
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
NULLNAME DigitsBind
::
  Digits			( D )
  HXS 2 A0 OVER PPow# SWAP	( DZ D )
  ' NULLLAM DUPTWO DOBIND
;

*---------------------------------------------------------------------
* Name:		Digits
* Stack:	( --> D )
* Desc:		Search for current user defined precision
*---------------------------------------------------------------------
NULLNAME Digits
::
  ' LAM DIGITS @LAM ITE
    TRUE
    :: ' ID DIGITS @ ;
  NOTcase TWENTY			( --> #20 )

  DUPTYPEREAL? NcaseTYPEERR
  DUP %2 %>				( %d d>2 )
  OVER % 10000 %< AND			( %d d>2&d<10000 )
  OVER %FP %0= AND			( %d d>2&d<10000&int )
  NcaseTYPEERR
  COERCE				( --> #d )
;

*---------------------------------------------------------------------
* Name:		Digits+
* Stack:	( #d --> DZ D )
* Desc:		Return current digits variables and increase
*		the active ones as indicated by #d. This is
*		used when calculating function values which
*		require approximations with possible error
*		propagation.
*---------------------------------------------------------------------
NULLNAME Digits+
::
  DZ D					( #d DZ D )
  DZ HXS 2 A0 5PICK PPow# QMul DZ!	( * New DZ = DZ*10^d * )
  D 4ROLL #+ D!				( * New D  = D+d * )
;

*---------------------------------------------------------------------
* Name:		Digits-
* Stack:	( DZ D Zm Ze --> Zm' Ze' )
* Desc:		Restore old precision and normalize number.
*		This is used to exit function evaluations
*		which have temporarily increased precision.
*---------------------------------------------------------------------
NULLNAME Digits-
::
  2SWAP D! DZ! Normalize
;

**********************************************************************
*		NORMALIZATION
**********************************************************************

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Name:		Normalize
* Stack:	( Zm Ze -- Zm' Ze' )
* Desc:		Normalize number to current precision.
*		This is usually the most time consuming part in
*		function evaluations since there is no simple
*		and fast way to do multiplications with automatic
*		normalizations. Thus we end up normalizing numbers
*		with twice the number of digits we need.
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
NULLNAME Normalize
::
   OVER QIsZero? casedrop DUP		( * Normalize zero * )

   OVER DZ ZNLT? ?SEMI			( * Is normalized * )

* We must use a flag to indicate whether rounding up has been done
* so we can decide what to do when we have a .5000000... in a later
* iteration.

* We take an appriximate logarithm in base 16 to get the number
* of digits in the input number. We underestimate the number a bit,
* but testing shows the loop is almost always passed only once.

   TRUE UNROT				( flag Zm Ze )

   BEGIN
	OVER LENHXS #1-			( flag Zm Ze #hi )
	DUP FIVE #MAX #5-		( flag Zm Ze #hi #lo )
	4PICKOVER 4ROLL SUBHXS		( flag Zm Ze #lo Z' )
	HXS>% %LOG			( flag Zm Ze #lo %log )
	SWAP DUP#0=ITE
	  DROP
	  :: #1- UNCOERCE Log16 %* %+ ;
	%CEIL COERCE			( flag Zm Ze #digits )
	D #-				( flag Zm Ze #k )
	DUP#0=IT #1+			( * Safety to avoid eternal loop * )

	( Divide exponents )

	DUPUNROT #>Z QAdd		( flag Zm #k Ze+k )

	( We calculate 10^k using the known 10^d result for speed )

	HXS 2 A0 ROT D #/		( flag Zm Ze+k Z10 #rem #quo )
	DZ SWAP PPow#			( flag Zm Ze+k Z10 #rem 10^k1 )
	UNROT PPow# QMul		( flag Zm Ze+k 10^k )

	( Divide mantissas )

	ROTOVER QDivRem			( flag Ze+k 10^k quo rem )

	( Do rounding )

	DUP QAdd ROT			( flag Ze+k quo 2rem 10^k )
	2DUP ZNLT? ITE
	   2DROP			( flag Ze+k quo )
	   ::
	      EQUAL ITE 3PICK TRUE	( flag Ze+k quo round? )
	      NOT?SEMI
	      ROTDROP FALSE UNROT	( FALSE Ze+k quo )
	      DupZIsNeg? ITE
	      HXS 2 1F HXS 2 10
	      QAdd			( FALSE Ze+k quo' )
	   ;

	( Exit if mantissa smaller than DZ )

	DUPUNROT DZ ZNLT?		( flag Zm' Ze' done? )
   UNTIL

   ROTDROP				( Zm' Ze' )
;


**********************************************************************
*		CONVERSION SUBROUTINES
**********************************************************************

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Name:		Str2Inf2
* Stack:	( $inf1 $inf2 --> Zm1 Ze1 Zm2 Ze2 )
* Desc:		Convert two numbers to internal form.
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
NULLNAME Str2Inf2
::
  SWAP Str2Inf
  ROT Str2Inf
;

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Name:		Str2Inf
* Stack:	( $inf --> Zm Ze )
* Desc:		Convert a number to internal form.
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
NULLNAME Str2Inf
::
   DUP CHR_. ONE POSCHR			( $ #posdot )
   DUP#0=csedrp
   ::					( * No dot in string * )
      DUP CHR_E ONE POSCHR		( $ #posexp )
      DUP#0=csedrp
      :: S>Z HXS 1 0 ;			( * No exp either - integer * )

      2DUP ONE SWAP#1- SUB$ S>Z		( $ #posexp Zm )
      UNROT #1+ MINUSONE SUB$ S>Z	( Zm Ze )
   ;

   2DUP ONE SWAP#1- SUB$		( $ #posdot $part1 )
   UNROT #1+ MINUSONE SUB$		( $part1 $part2 )

   DUP CHR_E ONE POSCHR			( $part1 $part2 #posexp )
   DUP#0=csedrp
   ::					( * No exponent * )
      DUPLEN$ #>Z QNeg UNROT		( Ze $part1 $part2 )
      !append$ S>Z SWAP			( Zm Ze )
   ;

   2DUP ONE SWAP#1- SUB$		( $part1 $part2 #posexp $part21 )
   UNROT #1+ MINUSONE SUB$		( $part1 $part21 $part22 )
   S>Z					( $part1 $part21 Ze )
   OVERLEN$ #>Z QSub			( $part1 $part21 Ze' )
   UNROT !append$ S>Z SWAP		( Zm Ze' )
;

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Name:		Inf2Str
* Stack:	( Zm Ze --> $inf )
* Desc:		Convert from internal form to a number
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
NULLNAME Inf2Str
::
  Normalize
  OVER QIsZero? case2drop tok0		( --> "0" )

* If exponent=0 then write out integer

  DupQIsZero? casedrop Z>S		( --> $ )

* Extract mantissa sign

  SWAP DupZIsNeg? DUP4UNROLL		( flg Ze Zm flg )
  IT ZAbs				( flg Ze |Zm| )

* Convert mantissa - always nonzero

  Z>S					( flg Ze $M )

* If mantissa has trailing zeros then remove them and adjust exponent
* so that we get the right display format

  CODE
		GOSBVL	=SAVPTR
		A=DAT1	A
		D0=A			D0 = ->$
		GOSBVL	=SKIPOB		D0 = ->$tail
		LCASC	'0'
		B=0	A		zeros=0
		B=B-1	A
-		B=B+1	A		zeros++
		D0=D0-	2
		A=DAT0	B
		?A=C	B
		GOYES	-
		A=B	A
		GOVLNG	=PUSH#ALOOP	( --> #d flg Ze $M #zeros )
  ENDCODE

  DUP#0=ITE
     DROP
     ::
        DUP #>Z 4ROLL QAdd UNROT	( flg Ze' $M #z )
        OVERLEN$ SWAP#- ONESWAP SUB$	( flg Ze' $M' )
     ;

* Convert the absolute value to a string

  ::

    OVER ZIsNeg? NOTcase

* Handle positive exponent

    ::					( flg Ze $M )

       ( * Count zeros to append and see if we'd have less than #d digits * )

       DUPLEN$ #>Z 3PICK QAdd		( flg Ze $M Zx )
       D #>Z ZNLT? case
       ::				( Append zeros to integer )
         SWAP HXS>#			( flg $M #exp )
         CODE				( Create #exp zeros )
infzeros	GOSBVL	=POP#
		GOSBVL	=SAVPTR
		C=A	A
		R4=C	A		R4[A] = #exp
		GOSBVL	=MAKE$
		A=R4	A		A[A] = #exp
		LCASC	'0'
-		A=A-1	A
		GOC	+		We may have 0 zeros to add!
		DAT0=C	B
		D0=D0+	2
		GONC	-
+		GOVLNG	=GPPushR0Lp
         ENDCODE
         !append$			( flg $ )
       ;

       ( * Use scientific notation * )

       DUP CAR$ SWAP CDR$		( flg Ze chr1 $cdr )
       DUPLEN$ #>Z 4ROLL QAdd		( flg chr1 $cdr Ze' )
       Z>S				( flg chr1 $cdr $E )
       CHR_E >H$ !append$
       CHR_. >H$ SWAP >H$		( flg $ )

    ;

* Handle negative exponent

    ( * See if decimal point is inside mantissa * )

    DUPLEN$ #>Z 3PICKSWAP ZNLT? case	( flg Ze $M )
    ::
       SWAP ZAbs HXS>#			( flg $M #exp )
       OVERLEN$ SWAP#-			( flg $M #pos )
       2DUP ONESWAP SUB$		( flg $M #pos $part1 )
       UNROT #1+ MINUSONE SUB$		( flg $part1 $part2 )
       CHR_. >H$ !append$		( flg $ )
    ;

    ( * See if we can insert zeros and not go over #d digits * )

    OVER D #1+ #>Z ZNLT? case		( flg Ze $M )
    ::
       DUPLEN$ #>Z ROT QAdd ZAbs HXS>#	( flg $M #zeros )
       CODE
		GOTO	infzeros	( flg $M $00 )
       ENDCODE
       !insert$ "0." !insert$		( flg $ )
    ;

    ( * Use scientific notation * )

    DUPLEN$ #1- #>Z ROT QAdd SWAPDUP	( flg Ze' $M $M )
    ONEONE SUB$ SWAP CDR$		( flg Ze' $car $cdr )
    DUPNULL$? ITE_DROP			( * No dot if only 1 digit * )
    :: CHR_. >H$ !append$ ;
    CHR_E >T$				( flg Ze' $..E )
    SWAP Z>S !append$			( flg Ze' $ )
  ;

* Handle sign
					( flg $ )
  CHR_- ROT ITE >H$ DROP		( Add mantissa sign )

;

**********************************************************************
*		INTERNAL FUNCTION EVALUATIONS
**********************************************************************

* Unary  functions have stack syntax ( Zm Ze --> Zm' Ze' )
* Binary functions have stack syntax ( Zm1 Ze1 Zm2 Ze2 --> Zm Ze )

**********************************************************************
NULLNAME InfAdd
::

* The exponent comparison section will drop the smaller number
* if the difference is too great. However the result will actually
* be the smaller number (with respect to exponent) if the other
* number is zero. Thus we have to detect zero separately.
* We also have to normalize since we compare number of digits.

  OVER QIsZero? case2DROP
  Normalize 2SWAP
  OVER QIsZero? case2DROP
  Normalize 2SWAP			( m1 e1 m2 e2 )
  
* If exponents differ we have to scale

  3PICKOVER QSub			( m1 e1 m2 e2 e1-e2 )
  DupZIsNeg? ITE
	ZAbs				( m1 e1 m2 e2 e2-e1 )
	:: 5ROLL 5ROLL ROT ;		( m2 e2 m1 e1 e1-e2 )
  DupQIsZero? ITE_DROP
     ::					( * Normalize to same exponent * )
	D #2* #>Z OVER ZNLT?
	casedrop			( * Too large difference * )
	:: 2SWAP 2DROP RDROP ;		( --> m2 e2 )
	DUPUNROT QSub
	ROT HXS 2 A0 4ROLL HXS># PPow#
	QMul SWAP
     ;
  DROP ROTSWAP QAdd SWAP		( m e )
  Normalize
;
**********************************************************************
NULLNAME InfSub
::
  InfNeg InfAdd
;
**********************************************************************
NULLNAME InfMul
::
  ROT QAdd UNROT QMul SWAP		( Zm1*Zm2 Ze1+Ze2 )
  Normalize
;
**********************************************************************
NULLNAME InfDiv
::
  ( Check zero divisor )
  OVER QIsZero? case ErrUndefRes
  ( Check zero dividend )
  4PICK QIsZero? case
  :: 3DROP DUP ;
  ( Normalize divisor )
  Normalize				( m1 e1 m2 e2 )
  ( Calculate exponent of quotient )
  ROTSWAP QSub				( m1 m2 e1-e2 )
  ( Calculate how many digits unscaled quotient would have )
  3PICK ZBits pullDROP			( m1 m2 e1-e2 #pow1 )
  3PICK ZBits pullDROP			( m1 m2 e1-e2 #pow1 #pow2 )
  ( Pretend more digits in divisor since we approximate digits )
  #3+
  ( Calculate digits )
  UNCOERCE2 %- Log2 %*			( m1 m2 e1-e2 %digits )
  ( Calculate by how many digits we need to scale m1 )
  D UNCOERCE SWAP %- COERCE		( m1 m2 e1-e2 #scale )
  ( Scale dividend )
  DUPUNROT #>Z QSub			( m1 m2 #scale e1-e2-scale )
  HXS 2 A0 ROT PPow#			( m1 m2 e1-e2-scale 10^scale )
  4ROLL QMul				( m2 e1-e2-scale m1' )
  ( Do the actual division )
  3PICK QDivRem				( m2 e1-e2-scale quo rem )
  ( Round up or down? )
  DUP QAdd 4ROLL ZNLT?			( e1-e2-scale quo noround? )
  :: case SWAP				( --> Zm Ze )
     DupZIsNeg? ITE
        HXS 2 1F HXS 2 10
     QAdd				( e1-e2-2d quo' )
     SWAP				( quo' e1-e2-2d )
  ;
  Normalize
;
**********************************************************************
NULLNAME InfInv
::
  HXS 2 10 HXS 1 0 2SWAP		( 1 0 m e )
  InfDiv
;
**********************************************************************
NULLNAME InfNeg
::
  SWAP QNeg SWAP			( -Zm1 Ze1 )
;
**********************************************************************
NULLNAME InfSqrt
::
  OVER ZIsNeg? case ErrUndefRes			( * Must be positive * )
  OVER QIsZero? casedrop DUP			( --> 0 0 )

  ( Taking square root halves digits. We assume we have numbers of )
  ( current precision, and thus have to scale with 10^d anyway..   )

  D #>Z QSub SWAP DZ QMul SWAP			( Zm' Ze' )

  ( Force exponent to be even since we have to /2 it )
  ZERO ZBit? IT
  :: SWAP HXS 2 A0 QMul SWAP HXS 2 10 QSub ;	( Zm' Ze' )

  ( Now calculate if we have to scale more to keep DIGITS precision )
  SWAP ZBits #1- UNCOERCE % 0.301029995664 %*	( Ze' Zm' %digits )
  ( We need to have atleast 2*D digits )
  D #2* UNCOERCE SWAP %- COERCE			( Ze' Zm' #needed )
  ( But we want to keep the scaled exponent even )
  DUPONE #AND #0=?SKIP #1+			( Ze' Zm' #needed' )
  ( Scale the number )
  HXS 2 A0 OVER PPow# ROT QMul UNROT #>Z QSub	( Zm'' Ze'' )

  ( Take square root )
  SWAP ZSQRT DROPSWAP HXS 2 20 QDiv		( Zm Ze )
  Normalize
;

**********************************************************************
NULLNAME InfPow
::
  ( Handle zero power )
  OVER QIsZero? case
  :: 4DROP HXS 2 10 HXS 1 0 ;
  ( Handle negative mantissa first )
  4PICK ZIsNeg? case
  ::
     3PICK ZIsNeg? case ErrUndefRes	( * Disallow fraction base * )
     DupZIsNeg? case ErrUndefRes	( * Disallow fraction power * )
     HXS 2 A0 SWAP ZPowZ QMul
     InfPowZ
  ;

  ( Handle smallish integer powers without exp & ln )
  DupQIsZero?
  3PICK HXS 6 00010 ZNLT? ANDcase
  :: DROP InfPowZ ;

  2SWAP InfLn InfMul InfExp
;
**********************************************************************
* Notes:	Ramanujan's formula for PI:
*
*	By induction if
*
*		          (6n)!
*		F(n) = ------------
*		       (n!)^3 (3n)!
*
*	then for n>=5
*
*		           F(n)
*		F(n+1) = ------- 2^3 (6n+5)(6n+3)(6n+1)
*		         (n+1)^3
*
*	By testing numerically (n+1)^3 will divide the full expression
*	also for 0<=n<=5. Thus the recurrence relation is valid
*	for all n if the division is done last.
**********************************************************************

NULLNAME InfPi
::
  FIVE Digits+
  HXS 2 10 HXS 7 1736FC0
  OVER HXS 1 0 ZERO
  BEGIN					( nf k2+0k1 8k4k5^0 S #n )
	DZ 6PICK 6PICK QMul QMul	( nf k2+0k1 8k4k5^0 S #n nom )
	4PICK QDiv			( nf k2+0k1 8k4k5^0 S #n dS )
	DupQIsZero? ITE
	    DROPTRUE
	    ::
		ROTSWAP			( nf k2+0k1 8k4k5^0 #n S dS )
		3PICK ONE #AND #0=ITE
		   QAdd QSub		( nf k2+0k1 8k4k5^0 #n S' )
		SWAP#1+			( nf k2+0k1 8k4k5^0 S' #n+1 )

		5ROLL HXS 2 80
		3PICK #6* #1-DUP #>Z
		SWAP #2- DUP #>Z
		SWAP #2- #>Z
		QMul QMul QMul QMul
		OVER #>Z DUPDUP QMul QMul QDiv
		5UNROLL			( nf' k2+0k1 8k4k5^0 S' #n+1 )

		4ROLL HXS 9 6AD2E7020
		QAdd 4UNROLL		( nf' k2+1k1 8k4k5^0 S' #n+1 )

		ROT HXS 10 00004B4C268B4A30
		QMul UNROT		( nf' k2+1k1 8k4k5^1 S' #n+1 )

		FALSE
	    ;
  UNTIL

  DROP 4UNROLL3DROP			( S' )
  D #>Z QNeg				( m e )
  HXS 5 51720 HXS 1 0 InfSqrt		( m e mq eq )
  HXS 6 083860 ROT QMul SWAP
  2SWAP InfDiv				( m' e' )
  Digits-
;

**********************************************************************
NULLNAME InfExp
::
  OVER QIsZero? case2drop
  :: HXS 2 10 HXS 1 0 ;			( exp[0] = 1 )

  SEVEN Digits+ 2SWAP			( * Increase precision * )

  Normalize				( * Full normalization * )
  SWAP DZ QMul SWAP D #>Z QSub
  Normalize

  ( Extract power of 10 so series will converge )

  DUP D #>Z ZNLT? ITE
  ::
    DupZIsNeg? NOTcase
    :: DUP ZAbs ;
    D #>Z OVER QAdd
  ;
  ::
    DupZIsNeg? case HXS 2 2F
    DUP D #>Z QAdd
  ;
  HXS 2 40 QAdd
  DUP4UNROLL QSub			( d m e' )

  ( Calculate Taylor series approximation )

  HXS 2 10 HXS 1 0
  2SWAP 2DUP
  6PICK ONE				( d 1 0 m e m e 1 # )

  BEGIN					( d s1 s2 m1 m2 p1 p2 n! #n )
	8ROLL 8ROLL			( d m1 m2 p1 p2 n! #n s1 s2 )
	6PICK 6PICK			( d m1 m2 p1 p2 n! #n s1 s2 p1 p2 )
	6PICK HXS 1 0 InfDiv
	2OVER InfAdd 2SWAP		( d m1 m2 p1 p2 n! #n s1' s2' s1 s2 )
	3PICK EQUAL SWAP4PICK EQUAL AND	( d m1 m2 p1 p2 n! #n s1' s2' flag )
	ITE
	    TRUE
	    ::
		8UNROLL 8UNROLL		( d s1' s2' m1 m2 p1 p2 n! #n )
		#1+DUP #>Z
		ROT QMul SWAP		( d s1' s2' m1 m2 p1 p2 n+1! #n+1 )
		4ROLL 4ROLL		( d s1' s2' m1 m2 n+1! #n+1 p1 p2 )
		6PICK 6PICK InfMul
		4UNROLL 4UNROLL		( d s1' s2' m1 m2 p1' p2' n+1! #n+1 )
		FALSE
	    ;
  UNTIL

  8UNROLL 8UNROLL 6DROP			( d s1 s2 )

  ( Raise to power of power of 10 )

  HXS 2 A0 4ROLL ZPowZ InfPowZ		( s1' s2' )

  ( Restore old precision )

  Digits-
;

**********************************************************************
NULLNAME InfLn
::
  OVER ZIsNeg?  case ErrUndefRes	( * Error for x<0 * )
  OVER QIsZero? case ErrInfRes		( * Error for x=0 * )

  FOUR Digits+ 2SWAP			( Increase precision )
  Normalize				( And normalize )

  ( Take square roots until within decade of 1 )
  ( * This is bad if we are already very close to 1 * )

  D #>Z QNeg DUP HXS 2 10 QAdd
  HXS 2 20 5ROLL 5ROLL			( e1 e2 2 m e )
  BEGIN
	ROT HXS 2 20 QMul UNROT		( e1 e2 2^i m e )
	InfSqrt				( e1 e2 2^i m' e' )
	4PICKOVER EQUAL
	6PICK 3PICK EQUAL OR		( e1 e2 2^i m' e' flag )
  UNTIL
  4ROLLDROP 4ROLLDROP			( 2^i m' e' )
  
  ( Take a few more to get faster convergence )

  SIX ZERO_DO (DO)
	ROT HXS 2 20 QMul UNROT		( 2^j m e )
	InfSqrt				( 2^j m' e' )
  LOOP

  ( Transform and calculate series approximation )

  2DUP  HXS 2 1F HXS 1 0 InfAdd
  2SWAP HXS 2 10 HXS 1 0 InfAdd
  InfDiv				( 2^k m' e' )

  HXS 1 0 HXS 2 10 2SWAP
  2DUP 2DUP InfMul
  2SWAP ONE 7UNROLL			( 2^k n s1 s2 m1 m2 p1 p2 )
  BEGIN
	6ROLL 6ROLL			( 2^k n m1 m2 p1 p2 s1 s2 )
	2OVER				( 2^k n m1 m2 p1 p2 s1 s2 p1 p2 )
	NINE PICK #>Z
	HXS 1 0 InfDiv
	2OVER InfAdd 2SWAP		( 2^k n m1 m2 p1 p2 s1' s2' s1 s2 )
	3PICK EQUAL SWAP4PICK EQUAL AND	( 2^k n m1 m2 p1 p2 s1' s2' flag )
	ITE
	    TRUE
	    ::
		6UNROLL 6UNROLL		( 2^k n s1' s2' m1 m2 p1 p2 )
		2OVER InfMul		( 2^k n s1' s2' m1 m2 p1' p2' )
		7ROLL #2+ 7UNROLL	( 2^k n+2 s1' s2' m1 m2 p1' p2' )
		FALSE
	    ;
  UNTIL
  7UNROLL 7UNROLL 5DROP			( 2^k s1 s2 )

  ( Multiply the square roots back in )

  UNROT QMul SWAP

  ( Restore precision )

  Digits-
;
**********************************************************************
NULLNAME InfSin
::
  FIVE Digits+ 2SWAP			( Increase precision )
  TrigNorm				( Force -pi/2 -- pi/2 )
  2DUP 2DUP 2DUP InfMul ONE		( z z^n z^2 #n )
  TrigSerie				( m e )
  Digits-				( Restore precision )
;
**********************************************************************
NULLNAME InfCos
::
  FIVE Digits+ 2SWAP			( Increase precision )
  TrigNorm				( Force -pi/2 -- pi/2 )
  HXS 2 10 HXS 1 0 2DUP			( z 1 1 )
  6ROLL 6ROLL 2DUP InfMul ZERO		( 1 z^n z^2 n )
  TrigSerie				( m e )
  Digits-				( Restore precision )
;

**********************************************************************
NULLNAME InfTan
::
  2DUP InfSin 2SWAP InfCos InfDiv
;

*---------------------------------------------------------------------
NULLNAME TrigSerie
::
  ROT QNeg UNROT			( s z^n -z^2 n )
  BEGIN					( s z^n -z^2 n )
     3PICK3PICK				( s z^n -z^2 n z^2 )
     7ROLL 7ROLL			( s -z^2 n z^2 z^n )
     InfMul				( s -z^2 n z^n+2 )
     ROT#1+ DUP#1+			( s -z^2 z^n+2 n+1 n+2 )
     DUP 5UNROLL			( s -z^2 n+2 z^n+2 n+1 n+2 )
     #* #>Z HXS 1 0 InfDiv		( s -z^2 n+2 z^n+2 )
     5UNROLL 5UNROLL			( s z^n+2 -z^2 n+2 )
     7ROLL 7ROLL 7PICK 7PICK		( z^n+2 -z^2 n+2 s z^n+2 )
     2OVER InfAdd 2SWAP			( z^n+2 -z^2 n+2 s' s )
     3PICK EQUAL SWAP4PICK EQUAL AND	( z^n+2 -z^2 n+2 s' f )
     UNROT 8UNROLL 8UNROLL		( s' z^n+2 -z^2 n+2 f )
  UNTIL
  5DROP					( s' )
;
*---------------------------------------------------------------------
* Desc:		Normalize to range -pi/2 -- pi/2
*---------------------------------------------------------------------
NULLNAME TrigNorm
::
  InfPi 2SWAP 2OVER			( pi x pi )
  SWAPDUP QAdd SWAP			( pi x 2pi )
  FOUR NDUP InfDiv InfIp		( pi x 2pi n )
  InfMul InfSub				( pi x' )
  2SWAP					( x' pi )
  FOUR NDUP InfCmp			( x' pi #cmp )
  #1= NOTcase2DROP			( --> x' )
  SWAPDUP QAdd SWAP			( x' 2pi )
  InfSub				( x'' )
;

**********************************************************************
NULLNAME InfASin
::
  OVER ZAbs OVER			( x |x| )
  HXS 2 10 HXS 1 0 InfCmp		( x #tst )
  DUP#0=csedrp				( * If |x|=1 * )
  :: DROP ZIsNeg?			( neg? )
     InfPi UNROTSWAP IT QNeg SWAP
     HXS 2 20 HXS 1 0 InfDiv		( * Then y=+-pi/2 * )
  ;
  #1=case ErrUndefRes			( * Complex for |x|>1 * )
  FIVE Digits+ 2SWAP			( * Increase precision * )
  2DUP 2DUP 2DUP InfMul ONE		( z z^n z^2 n )
  BEGIN
      3PICK3PICK 7ROLL 7ROLL		( s z^2 n z^2 z^n )
      InfMul				( s z^2 n z^n+2 )
      ROTDUP DUP #*			( s z^2 z^n+2 n n^2 )
      SWAP#1+ DUP#1+			( s z^2 z^n+2 n^2 n+1 n+2 )
      DUP 6UNROLL			( s z^2 n+2 z^n+2 n^2 n+1 n+2 )
      #* #>Z HXS 1 0 ROT #>Z OVER 2SWAP	( s z^2 n+2 z^n+2 n^2 n+1*n+2 )
      InfDiv				( * n^2/[n+1][n+2] is the ratio * )
      InfMul				( s z^2 n+2 z^n+2 )
      5UNROLL 5UNROLL			( s z^n+2 z^2 n+2 )
      7ROLL 7ROLL 7PICK 7PICK		( z^n+2 z^2 n+2 s z^n+2 )
      2OVER InfAdd 2SWAP		( z^n+2 z^2 n+2 s' s )
      3PICK EQUAL SWAP4PICK EQUAL AND	( z^n+2 z^2 n+2 s' f )
      UNROT 8UNROLL 8UNROLL		( s' z^n+2 z^2 n+2 f )
  UNTIL
  5DROP Digits-
;
**********************************************************************
NULLNAME InfACos
::
  InfASin				( asin )
  InfPi HXS 2 20 HXS 1 0 InfDiv		( asin pi/2 )
  2SWAP InfSub				( pi/2-asin )
;
**********************************************************************
NULLNAME InfATan
::
  OVER ZAbs OVER			( x |x| )
  HXS 2 10 HXS 1 0 InfCmp		( x #tst )
  DUP#0=csedrp				( * If |x|=1 * )
  :: DROP ZIsNeg?			( neg? )
     InfPi UNROTSWAP IT QNeg SWAP
     HXS 2 40 HXS 1 0 InfDiv		( * Then y=+-pi/4 * )
  ;
  UNROT					( #tst x )
  FIVE Digits+ 2SWAP 5ROLL		( x #tst )
  #1= DUP4UNROLL IT InfInv		( TRUE 1/x  /  FALSE x )
  2DUP 2DUP 2DUP InfMul InfNeg ONE	( z z^n -z^2 n )
  BEGIN
      #2+				( s z^n -z^2 n+2 )
      3PICK3PICK 7ROLL 7ROLL InfMul	( s -z^2 n+2 z^n+2 )
      5UNROLL 5UNROLL			( s z^n+2 -z^2 n+2 )
      7ROLL 7ROLL 7PICK 7PICK		( z^n+2 -z^2 n+2 s z^n+2 )
      5PICK #>Z HXS 1 0 InfDiv		( * ratio is 1/n * )
      2OVER InfAdd 2SWAP		( z^n+2 -z^2 n+2 s' s )
      3PICK EQUAL SWAP4PICK EQUAL AND	( z^n+2 -z^2 n+2 s' f )
      UNROT 8UNROLL 8UNROLL		( s z^n+2 -z^2 n+2 s' )
  UNTIL
  5DROP
  ROT IT				( * pi/2-serie if 1/x * )
  :: InfPi HXS 2 20 HXS 1 0 InfDiv
     2SWAP InfSub
  ;
  Digits-
;

**********************************************************************
NULLNAME InfSinh
::
  2DUP InfExp
  2SWAP InfNeg InfExp
  InfSub
  HXS 2 50 HXS 2 1F InfMul
;
**********************************************************************
NULLNAME InfCosh
::
  2DUP InfExp
  2SWAP InfNeg InfExp
  InfAdd
  HXS 2 50 HXS 2 1F InfMul
;
**********************************************************************
NULLNAME InfTanh
::
  2DUP InfExp
  2SWAP InfNeg InfExp
  FOUR NDUP InfSub
  6UNROLL 6UNROLL
  InfAdd InfDiv
;
**********************************************************************
NULLNAME InfASinh
::
  2DUP 2DUP InfMul
  HXS 2 10 HXS 1 0 InfAdd
  InfSqrt InfAdd InfLn
;
**********************************************************************
NULLNAME InfACosh
::
  2DUP HXS 2 10 HXS 1 0 InfCmp
  MINUSONE #=case ErrUndefRes		( * Compex for x<1 * )
  2DUP 2DUP InfMul
  HXS 2 1F HXS 1 0 InfAdd
  InfSqrt InfAdd InfLn
;
**********************************************************************
NULLNAME InfATanh
::
  OVER ZAbs OVER
  HXS 2 10 HXS 1 0 InfCmp
  MINUSONE #<>case ErrUndefRes		( * Complex for |x|>=1 * )
  HXS 2 10 HXS 1 0 2SWAP
  FOUR NDUP InfAdd
  6UNROLL 6UNROLL InfSub
  InfDiv InfLn
  HXS 2 20 HXS 1 0 InfDiv
;
**********************************************************************
* Stack:	( x y --> #tst )
* Desc:		Compare two numbers in current precision.
*		x<y : MINUSONE
*		x=y : ZERO
*		x>y : ONE
**********************************************************************	
NULLNAME InfCmp
::
  InfSub DROP
  DupQIsZero? casedrop ZERO		( --> ZERO )
  ZIsNeg? case MINUSONE			( --> MINUSONE )
  ONE					( --> ONE )
;
**********************************************************************
NULLNAME InfIp
::
  Normalize
  DupZIsNeg? NOT?SEMI			( * Exponent >=0 - is integer * )
  ZAbs
  DUP D #>Z ZNLT? NOTcase2drop
  :: HXS 1 0 DUP ;			( * Exponent < d - is fraction * )
  HXS 2 A0 SWAP ZPowZ QDiv HXS 1 0
;
**********************************************************************
NULLNAME InfFp
::
  2DUP InfIp InfSub
;

**********************************************************************
*			HELP UTILITIES
**********************************************************************

**********************************************************************
* Name:		ZPowZ
* Stack:	( Z P --> Z^P )
* Desc:		Raise integer to integer power (exact)
**********************************************************************
NULLNAME ZPowZ
::
  ZBits
  DUP#0=csedrp
  :: 2DROP HXS 2 10 ;			( Z^0 = 1 )
  DUP#1= case2DROP			( Z^1 = Z )
  HXS 2 10 4UNROLL			( 1 Z P #n )
  ZERO_DO (DO)
	INDEX@ ZBit? IT
	:: ROT 3PICK QMul UNROT ;
	SWAPDUP QMul SWAP
  LOOP
  2DROP
;

**********************************************************************
* Name:		InfPowZ
* Stack:	( m e Z --> m' e' )
* Desc:		Raise number to exact integer power
**********************************************************************
NULLNAME InfPowZ
::
  3PICK QIsZero? case2drop DUP		( 0^n = 0 )
  ZBits
  DUP#0=csedrp
  :: 3DROP HXS 2 10 HXS 1 0 ;		( z^0 = 1 )
  DUP#1= case2DROP			( z^1 = z )
  HXS 2 10 HXS 1 0 6UNROLL 6UNROLL	( 1 0 Z1 Z2 P #n )
  ZERO_DO (DO)
	INDEX@ ZBit? IT
	:: 5ROLL 5ROLL
	   5PICK 5PICK
	   InfMul
	   5UNROLL 5UNROLL
	;
	UNROT
	2DUP InfMul
	ROT
  LOOP
  UNROT2DROP ZIsNeg? NOT?SEMI
  InfInv
;

**********************************************************************
