ASSEMBLE
         NIBASC    /HPHP48-E/
RPL
::
 CK1NOLASTWD
 CK&DISPATCH1 TWELVE
 ::
  CKREF
  CODE
CARRY    EQU     0         ;a bit in the ST register
         GOSBVL  =SAVPTR
         A=DAT1  A
         D1=A
         A=DAT1  A         ;check prolog
         LC(5)   =DOGROB
         ?A=C    A
         GOYES   GROBOK
EXITNOW1 GOTO    EXITNOW
GROBOK   D1=D1+  10
         A=DAT1  A         ;height
         A=A-1   A
         GOC     EXITNOW1
         R0=A.F  A         ;Y count, height-1
         D1=D1+  5
         A=DAT1  A
         R1=A.F  A         ;width (pixels)
         SB=0                  ;- nibs:=pixels div 4;
         ASRB.F  A             ;- if (pixels mod 4) > 0 inc(nibs);
         ASRB.F  A             ;- if odd(nibs) inc(nibs);
         ?SB=0
         GOYES   NOREMAIN
         A=A+1   A
NOREMAIN ?ABIT=0 0
         GOYES   EVEN
         A=A+1   A
EVEN     ?A=0    A
         GOYES   EXITNOW1
         R2=A.F  A         ;X count, width (nibs)
         D1=D1+  5         ; D1 -->ROW1
         CD1EX
LINELOOP D1=C              ; D1 -->left side byte
         RSTK=C            ;save line start location
* shift line right ( (8-(grobwidth & 7)) & 7) pixels
* because overall grob width is byte aligned
         C=R1.F  B         ;grobwidth (pixels)
         LA(2)   7
         C=C&A   B
         A=A+1   B
         A=A-C   B
         LC(2)   7
         C=C&A   B
         D=C     B
NEXTBIT  D=D-1   B
         GOC     FLIPLINE  ;no shifting, was byte aligned already
         A=R2.F  A         ;nibs in line
         B=A     A
         C=RSTK
         RSTK=C
         D0=C              ;start of current line
         ST=0    CARRY     ;clear carry
NEXTSHFT C=0     A
         LC(2)   16        ;max nibs in shift register
         ?B>=C   A         ;have less than max nibs left?
         GOYES   SL1
         C=B     A         ;yes, use that number
SL1      B=B-C   A         ;remaining nibs in line
         C=C-1   A         ;now 0-F value for WP field select
         GOC     FLIPLINE  ;error
         P=C     0
         A=DAT0  WP
         A=A+A   WP        ;shift left
         GONC    NOCARRY
         ?ST=1   CARRY     ;have a carry from previous shift?
         GOYES   SETABIT
         ST=1    CARRY
         GOTO    SL2
NOCARRY  ?ST=0   CARRY
         GOYES   SL2
         ST=0    CARRY
SETABIT  ABIT=1  0
SL2      DAT0=A  WP
         CD0EX
         C=C+P+1
         D0=C
         P=      0
         ?B#0    A
         GOYES   NEXTSHFT
         GOTO    NEXTBIT
* flip the grob left<-->right
FLIPLINE C=RSTK            ;start of current line
         RSTK=C
         A=R2.F  A         ;line width in nibs
         C=C+A   A
         D0=C              ; -->right side byte + 1
         ASRB.F  A
         ASRB.F  A
         B=A     A         ;bytes per line div 2
SWAPLOOP D0=D0-  2         ; D0 -->right side byte, D1 -->left side byte
         B=B-1   A
         GOC     HALFWAY   ;go if at the half way point
         C=DAT1  B
         GOSUB   REVBITS
         D=C     B
         C=DAT0  B
         GOSUB   REVBITS
         DAT1=C  B
         C=D     B
         DAT0=C  B
         D1=D1+  2
         GOTO    SWAPLOOP
HALFWAY  A=R2.F  A
         ?ABIT=0 1
         GOYES   NEXTLINE
         C=DAT0  B         ;byte in middle if odd bytes
         GOSUB   REVBITS
         DAT0=C  B
NEXTLINE C=RSTK            ;start of current line
         A=R2.F  A         ;line width in nibs
         C=C+A   A         ;start of next line
         A=R0.F  A         ;decr y count
         A=A-1   A
         R0=A.F  A
         GOC     EXITNOW
         GOTO    LINELOOP
EXITNOW  GOVLNG  =GETPTRLOOP

* REVBITS and REVBITSN require P=0 on entry, both trash A(W)
*   but leave rest of C unchanged, REVBITS uses 1 stack level
REVBITS  A=C     B             ;reverse bits in C(B) byte
         ASR     B
         CSL     B
         C=C!A   B
         CSRC
         GOSUB   REVBITSN
         CSLC
REVBITSN SB=0                  ;reverse bits in C(0) nibble
         CSRB.F  P
         CBIT=1  3
         P=C     0
         LAHEX   042615370
         P=      0
         C=A     P
         ?SB=0
         RTNYES
         CBIT=1  3
         RTN
  ENDCODE
 ;
;
