***count.s********************************************************************
*                                                                            *
* Name: count                                                                *
*                                                                            *
* Category: Utility                                                          *
*                                                                            *
* Stack Levels: 2                                                            *
*                                                                            *
* Entry:  $ $                                                                *
*                                                                            *
* Exit:  { }                                                                 *
*                                                                            *
* Calls: PopASavptr, GETTEMP, GPPushALp, GPErrjmpC                           *
*                                                                            *
* Registers: A, B, C, D, D1, D0.                                             *
*           R4 -> Character to look for                                      *
*           R3 -> Begining of $ to search                                    *
*           R2 -> Size of $ -1 then Addr of {}                               *
*                                                                            *
* Description: This routine will search a string for the specified character *
*              and will return a list of real numbers where the character    *
*              was found.  A NULL{} will be returned if the character was not*
*              found.                                                        *
*                                                                            *
*                                                                            *
* Written:      7/19/94         Will Laughlin                                *
* rewritten:    30.11.94        Will Laughlin                                *
******************************************************************************
CODE
	GOSBVL  =PopASavptr     
	C=DAT1  A
	D1=C
	D0=A            
	LC(5)   =DOCSTR
	A=DAT0  A
	?A#C    A
	GOYES   not$
	A=DAT1  A
	?A#C    A
	GOYES   not$
	D0=D0+  5
	A=DAT0  A
	A=A-CON A,5
	?A#0    A
	GOYES   good
null$
	LC(5)   #203  
errorout        
	GOVLNG  =GPErrjmpC
not$
	LC(5)   #202
	GOC    errorout
good        
	D0=D0+  5
	A=DAT0  B
	R4=A            
	GOSBVL  =GetStrLen
	C=C-1   A       
	GOC     null$
	R2=C            
	D=C     A       
	CD1EX           
	R3=C            
	D1=C            
	B=0     A       
Lp      
	C=DAT1  B       
	?A=C    B       
	GOYES   Add1    
next    
	D1=D1+  2       
	D=D-1   A      
	GONC    Lp      
	GOC     CONT
Add1    
	B=B+1   A       
	GONC    next    
CONT    
	A=B     A       
	C=0     A
	LC(2)   #15     
	GOSBVL  =MUL#   
	LC(1)   10       
*       C=C+CON A,10
	C=C+B   A
	GOSBVL  =GETTEMP       
	AD0EX           
	D0=A            
	AR2EX           
	B=A     A       
	A=R4            
	C=R3            
	D1=C            
	LC(5)   =DOLIST 
	DAT0=C  A       
	D0=D0+  5       
	D=0     A       
	D=D+1   A       
Lp2     
	C=DAT1  B       
	?A=C    B      
	GOYES   ADDLST  
NEXT    
	D=D+1   A       
	D1=D1+  2       
	B=B-1   A       
	GONC    Lp2      
	LC(5)   =SEMI
	DAT0=C  A       
	A=R2            
	GOVLNG  =GPPushALp      
ADDLST  
	LC(5)   =DOREAL 
	DAT0=C  A       
	D0=D0+  5       
	C=D     A       
	A=C     A       
	GOSUB   Uncoerce       
	DAT0=A  W       
	D0=D0+  16      
	A=R4           
	GONC    NEXT   
Uncoerce
	CBEX    A
	RSTK=C
	LC(2)   #19
	B=0     W
L18DD9  B=B+B   W
	SETHEX
	A=A+A   A
	SETDEC
	GONC    L18DE8
	B=B+1   W
L18DE8  C=C-1   B
	GONC    L18DD9
	P=      5
	A=A-1   X
L18DF3  A=A+1   X
	BSRC
	?B#0    WP
	GOYES   L18DF3
	BSR     W
	A=B     M
	A=0     S
	P=      0
	C=RSTK
	B=C     A
	SETHEX
	RTN
ENDCODE

