%%HP: T(1)A(R)F(.);
"!RPL
!NO CODE
DEFINE sAlcuin #9  ( Be sure not to be 0,1,2,11 or 12, since they are used by DeepSleep )

( FOR GX ONLY! )
DEFINE BSWADDR $7F000
DEFINE LINECOUNTg $8069A
DEFINE CONFTAB $8052B

::
 CK0
 ALARM? ?SEMI   ( if Alarm Due, skip off )
 CODE
  GOSBVL =SAVPTR
  CLRST AD0EX A+A.A SKIPNC { ST=1.sAlcuin }
  GOSUB OFF.SBR
  GOVLNG =GETPTRLOOP
  
  %Entry:  ST.sAlcuin must be set on G series
  %Output: None
  *OFF.SBR
  GOSBVL =DisableIntr
  ?ST=1.sAlcuin  {
   %We disable the Bank Switcher
   D0=(5)BSWADDR C=DAT0.B
   %We enable the ROM
   D0=(5)LINECOUNTg
   C=DAT0.B CBIT=1.7 DAT0=C.B
   D0=(5)LINECOUNT DAT0=C.B
  }
  ST=0.0 GOSBVL =DeepSleep %IF ST=1.0 THEN IT WILL CRASH
  ?ST=1.sAlcuin  {
   %We disable the Bank Switcher (it will be enabled by the system)
   D0=(5)BSWADDR C=DAT0.B
   %We disable the ROM
   %On GX or extended G only!
   D0=(5)CONFTAB+#10 A=DAT0.B ?A=0.P EXIT %If on a G, then exit
   D0=(5)LINECOUNTg
   C=DAT0.B CBIT=0.7 DAT0=C.B
   D0=(5)LINECOUNT DAT0=C.B
  }
  GOVLNG =AllowIntr %enable the interrupt and exit
 ENDCODE
 InitEnab ( I don't think it is needed, but that's what they do in the ROM)
;
@"