**********************************************************************
* Desc:		Solve integer Diophantone equation
* Stack:	( a b c --> { a a0 a1 } { b b0 b1 } c )
*		where 'a*(a0+a1*k)+b*(b0+b1*k)=c' for k in Z
**********************************************************************
::
  CK3
  FastLib CK3Z
  ZERO
  {{ a b c p }}
  b HXS 1 0 HXS 2 10 THREE{}N
  a HXS 2 10 HXS 1 0 THREE{}N
  BEGIN
	DUP CARCOMP
	QIsZero? NOT
  WHILE
	SWAP2DUP CARCOMP
	OVER CARCOMP
	QDiv QMul QSub
  REPEAT
  DROP
  c OVER CARCOMP QDivRem
  QIsZero? NOTcase2drop
  :: ABND FAIL ;
  OVER CARCOMP p!
  QMul INCOMPDROP ROTDROP
  a Z>S ROT Z>S b p QDiv Z>S
  THREE{}N
  b Z>S ROT Z>S a p QDiv QNeg Z>S
  THREE{}N
  c Z>S
  ABND
;
**********************************************************************
