**********************************************************************
*		ALG48 EXTERNALS
**********************************************************************

EXTERNAL xRSIM		
EXTERNAL xFCTR		
EXTERNAL xAADD		
EXTERNAL xASUB		
EXTERNAL xAMUL		
EXTERNAL xADIV		
EXTERNAL xAPOW		
EXTERNAL xANEG		
EXTERNAL xAINV		
EXTERNAL xMDET		
EXTERNAL xMLU		
EXTERNAL xMTRN		
EXTERNAL xMIDN		
EXTERNAL xZ<->S		( alias ZS )
EXTERNAL xGCD		
EXTERNAL xLCM		
EXTERNAL xRAT\8D	
EXTERNAL xASIM 
EXTERNAL xMOD+
EXTERNAL CKSymbMod
EXTERNAL xMOD-	
EXTERNAL xMOD*	
EXTERNAL xMOD/	
EXTERNAL xMODPOW	
EXTERNAL xMODINV
EXTERNAL xPRIM?	
EXTERNAL xPRIM+	
EXTERNAL xPRIM-	
EXTERNAL xRORD
EXTERNAL xPF	
EXTERNAL xRINT	
EXTERNAL xGBASIS
EXTERNAL xGSIMP
EXTERNAL xGSOLVE

** fastlib

EXTERNAL FastLib

** algerr

EXTERNAL ErrBadDim
EXTERNAL ErrUndefRes
EXTERNAL ErrInfRes

** verbose

EXTERNAL Verbose1
EXTERNAL Verbose2
EXTERNAL Verbose3
EXTERNAL VerboseN

** grobner

EXTERNAL EQS2R		( {eqs} {vars} --> Lp Lvars )
EXTERNAL R2EQS		( Lp Lvars --> {polys} )
EXTERNAL GBASIS		( Lp --> G )
EXTERNAL GSOLVE		( Lp --> Lg )
EXTERNAL GFACTOR	( Lp fctr? --> Lg )
EXTERNAL GFACTOR2	( --> )
EXTERNAL GSPLIT		( --> )
EXTERNAL GREDUCE	( --> )
EXTERNAL REDUCESOL	( Lg --> Lg' )
EXTERNAL SPOLY		( p q --> spoly )
EXTERNAL GSORT		( pairs Meta --> pairs' Meta' )
EXTERNAL REDFIND	( G --> G #Gi )
EXTERNAL NEWPAIR	( pairs #i #j --> pairs' )
EXTERNAL REMPAIRS	( pairs #i --> pairs' )
EXTERNAL NEXTPAIR	( pairs G --> pairs' #i #j TRUE / #0 FALSE )
EXTERNAL HTERM		( p --> hterm )
EXTERNAL SPLIT		( p #i --> p1 p2 )
EXTERNAL FINDSPLIT	( p G --> p G #i #Gi )
EXTERNAL REDUCE		( p G --> q )
EXTERNAL FASTREDUCE	( p G --> q TRUE / p G FALSE )

** algsmat

EXTERNAL MM2MS		( MM --> MM FALSE / MM MS TRUE )
EXTERNAL MS2MM		( MS --> MM )
EXTERNAL MScrout	( MS --> MS' FALSE / MS' #rank TRUE )
EXTERNAL MSsolvetri	( MS --> MS' flag )

** algconv

EXTERNAL CK1Z		(         ob1 --> Z1		/ Error )
EXTERNAL CK2Z		(     ob1 ob2 --> Z1 Z2		/ Error )
EXTERNAL CK3Z		( ob1 ob2 ob3 --> Z1 Z2 Z3	/ Error )
EXTERNAL H>Z		(         HXS --> Z		/ Error )
EXTERNAL #>Z		(           # --> Z			)
EXTERNAL Z>R		(           Z --> %			)
EXTERNAL R>Z		(           % --> Z		/ Error )
EXTERNAL Z>S		(           Z --> $			)
EXTERNAL S>Z		(           $ --> Z		/ Error )

** algmod

EXTERNAL ModPow		( Zb Zp Zn --> Z )
EXTERNAL Mod		(    Zb Zn --> Z )
EXTERNAL ModAdd		( Za Zb Zn --> Z )
EXTERNAL ModSub		( Za Zb Zn --> Z )
EXTERNAL ModMul		( Za Zb Zn --> Z )
EXTERNAL ModDiv		( Za Zb Zn --> Z )
EXTERNAL ModInv		(    Zb Zn --> Z )

EXTERNAL PEvalMod	(   Q Z Zn --> Q' )
EXTERNAL QMod		(     Q Zn --> Q' )
EXTERNAL QAddMod	( Q1 Q2 Zn --> Q' )
EXTERNAL QSubMod	( Q1 Q2 Zn --> Q' )
EXTERNAL QMulMod	( Q1 Q2 Zn --> Q' )
EXTERNAL QDivMod	( Q1 Q2 Zn --> Qquo Qrem )
EXTERNAL QInvMod	(     Q Zn --> Q' )
EXTERNAL QGcdMod	( Q1 Q2 Zn --> Q' )
EXTERNAL QGcdExMod	( Q1 Q2 Zn --> Q1' Q2' )

** algprime

EXTERNAL Prime+		( Z --> Z' )
EXTERNAL Prime-		( Z --> Z' )

EXTERNAL ZFactor	( Z --> Lf )
EXTERNAL NFactor	( N --> Lf )
EXTERNAL NFactorSpc	( N --> Lf | Z1 )
EXTERNAL DupTypeS?	( Z --> S TRUE / B FALSE )

EXTERNAL SFactor	( S --> Lf )
EXTERNAL SPollard	( S --> S1 S2 )

EXTERNAL BFactor	( B --> Lf )
EXTERNAL BrentPow	( Za Z1 Z2 Zn #k --> Z )

EXTERNAL ZPrime?	( Z --> flag )
EXTERNAL ZIsPrime?	( Z --> flag )
EXTERNAL SIsPrime?	( S --> flag )
EXTERNAL BIsPrime?	( B --> flag )
EXTERNAL BRabin		( Z #base --> Z flag )

EXTERNAL ZTrialPrime?	( Z --> flag )
EXTERNAL ZTrialDiv	( Z --> Mf Z' )

** algzcmp

EXTERNAL DupQIsZero?	( Q --> Q flag )
EXTERNAL QIsZero?	( Q --> flag )
EXTERNAL DupZIsOne?	( Z --> Z flag )
EXTERNAL ZIsOne?	( Z --> flag )
EXTERNAL DupZIsTwo?	( Z --> Z flag )
EXTERNAL ZIsTwo?	( Z --> flag )
EXTERNAL DupZIsNeg?	( Z --> Z flag )
EXTERNAL DupZIsEven?	( Z --> Z flag )
EXTERNAL ZIsNeg?	( Z --> flag )

EXTERNAL Univar?	( P --> P flag )
EXTERNAL SUnivar?	( P --> P flag )

EXTERNAL ListPos	( ob {} --> #i / #0 )
EXTERNAL AppendList	( {} ob --> {}' )
EXTERNAL Contains?	( ob1 ob2 --> ob1 ob2 flag )

EXTERNAL ZBits		( Z --> Z #bits )
EXTERNAL ZBit?		( Z #bit --> Z flag )

EXTERNAL ZTrim		( Z --> Z' )
EXTERNAL ZAbs		( Z --> |Z| )
EXTERNAL PNMax		( P --> Z )
EXTERNAL ZNMax		( Z1 Z2 --> NormMax[Z1,Z2] )
EXTERNAL ZNMin		( Z1 Z2 --> NormMin[Z1,Z2] )
EXTERNAL ZNLT?		( Z1 Z2 --> flag )

** algqarth

EXTERNAL QSub		( Q1 Q2 --> Q1-Q2 )
EXTERNAL QAdd		( Q1 Q2 --> Q1+Q2 )
EXTERNAL QNeg		( Q --> -Q )
EXTERNAL QMul		( Q1 Q2 --> Q1*Q2 )

** algdiv

EXTERNAL EuclidDiv	( A B --> q1 q2 r1 r2 )
EXTERNAL PseudoDiv	( A B --> q r c )
EXTERNAL QDiv?		( Q1 Q2 --> Q TRUE / FALSE )
EXTERNAL QDiv		( Q1 Q2 --> Q1/Q2 )
EXTERNAL QDivRem	( Q1 Q2 --> Q1/Q2 Q1remQ2 )
EXTERNAL PRemP		( P1 P2 --> P1/P2 P1remP2 )

** alggcd

EXTERNAL QGcd		( Q1 Q2 --> GCD[Q1,Q2] )
EXTERNAL QLcm		( Q1 Q2 --> LCM[Q1,Q2] )
EXTERNAL QGcd?		( Q1 Q2 --> GCD[Q1,Q2] / FALSE )
EXTERNAL ZGcd		( Z1 Z2 --> GCD[Z1,Z2] )

** algpolyz

EXTERNAL CKMkP		( pn .. p1 n -> P )
EXTERNAL MkCstP		( Q #n -> Q' )
EXTERNAL MkSplP		( #n #k -> P )
EXTERNAL DoP	  	( P proc --> P' )
EXTERNAL DoPS   	( P S proc --> P' )
EXTERNAL PPow#		( P # --> P^# )
EXTERNAL PEval		( Pn Z --> Pn-1 )
EXTERNAL PEvalFast?	( Z Pn --> Z Pn FALSE / Pn[Z] TRUE )
EXTERNAL PZadic		( Pn-1 Z --> Pn )
EXTERNAL PZCont		( P --> Z )
EXTERNAL PZContRPL	( P --> Z )
EXTERNAL PPZ		( P --> PP Z )
EXTERNAL PPP		( P --> PP PC )
EXTERNAL PDer		( P --> P' )
EXTERNAL PSetSign	( P1 P2 --> sign[P2]*P1 )
EXTERNAL PLCZ		( P --> Z )
EXTERNAL PTrim		( P --> P' )
EXTERNAL Variables	( P --> P #vars )

** algrat

EXTERNAL RAdd		( An Ad Bn Bd --> Cn Cd )
EXTERNAL RSub		( An Ad Bn Bd --> Cn Cd )
EXTERNAL RMul		( An Ad Bn Bd --> Cn Cd )
EXTERNAL RPow		( An Ad Z --> Cn Cd )
EXTERNAL RGcd		( An Ad Bn Bd --> Gn Gd )
EXTERNAL RLcm		( An Ad Bn Bd --> Gn Gd )

** algsimp

EXTERNAL ARSim		( Sym --> Sym' )
EXTERNAL RSim		( Sym --> Sym' )
EXTERNAL RSim0		( Sym --> Pn Pd vars )
EXTERNAL RSimVars	( symb {vars} --> P Q Lvars )
EXTERNAL RCanno		( P1 P2 --> P1' P2' )
EXTERNAL CKSymList	( {} --> {} / error )

** algsmeta

EXTERNAL CKSymb1	( obj --> symb )
EXTERNAL CKSymbN	( Meta --> symb )
EXTERNAL SNeg		( Meta --> Meta&NEG )
EXTERNAL SSign		( sflag Meta --> Meta' )
EXTERNAL SAdd		( Meta1 Meta2 --> Meta )
EXTERNAL SSub		( Meta1 Meta2 --> Meta )
EXTERNAL SMul		( Meta1 Meta2 --> Meta )
EXTERNAL SDiv		( Meta1 Meta2 --> Meta )
EXTERNAL SPow#		( Meta # --> Meta' )

** algsym2r

EXTERNAL M2Z		( M --> Z )

EXTERNAL SortList	( L pred --> L' )
EXTERNAL IsV>V?		( v1 v2 --> flag )
EXTERNAL PVars{}	( symb Lvars --> Lvars' )
EXTERNAL PVars		( Symb --> L )
EXTERNAL PVarSub	( M --> - )

EXTERNAL A2R		( Symb v --> Pn Pd )
EXTERNAL A2Rsub		( M --> Pn Pd )
EXTERNAL AA2RR{}	( Ap Aq vars --> v Pn Pd Qn Qd )
EXTERNAL AA2PP{}	( Ap Aq vars --> v P Zp Q Zq )
EXTERNAL AA2PP1{}	( Ap Aq vars --> v P Q )
EXTERNAL AA2RR		( Ap Aq --> v Pn Pd Qn Qd )
EXTERNAL AA2PP		( Ap Aq --> v P Zp Q Zq )

EXTERNAL TypeMod2?	( sym1 sym2 --> sym1 sym2 FALSE / v P1 P2 Zn TRUE )
EXTERNAL TypeMod1?	( sym --> sym FALSE / v P Zn TRUE )
EXTERNAL TypeMod?	( sym --> sym FALSE / sym' Zn )

EXTERNAL AAGcd		( Ap Aq --> Agcd )
EXTERNAL AALcm		( Ap Aq --> Alcm )
EXTERNAL RNumDen	( A -> An Ad )

** algr2sym

EXTERNAL RGetSign	( A B --> sflag |A| B )

EXTERNAL ZZ2SSF		( Zn Zd --> sflag Meta )
EXTERNAL R2S		( Qn Qd --> Meta )
EXTERNAL QZ2S		( Q Z --> Meta )
EXTERNAL PZ2S		( P Z --> Meta )
EXTERNAL Poly2Ssub

EXTERNAL R2SF		( Qn Qd --> Meta )
EXTERNAL R2A		( P Q v --> Symb )

EXTERNAL FF2SS		( { {F1 #k1} .. { Fm #km} } Zn Zd --> sflag Meta )
EXTERNAL QZFact2S	( Q Zq --> Meta )
EXTERNAL RFact2S	( P Q v --> Meta )
EXTERNAL R2FA		( P Q v --> Symb )

EXTERNAL FFactor	( Sym --> Sym' )
EXTERNAL ZFactorSym	( Z --> Sym )
EXTERNAL RFactor	( Sym --> Sym' )

EXTERNAL P2AMOD		( P Zn v --> Symb )

EXTERNAL ROrder		( Sym LMainVars --> Sym' )
EXTERNAL R2Aord		( P Q Lvars #main --> Sym' )

** algxsymb

EXTERNAL SYNeg		( S --> -S )
EXTERNAL DrpSYNeg	( S ob --> -S )
EXTERNAL SYAdd		( S1 S2 --> S1+S2 )
EXTERNAL SYAdd%		( S % --> S+% )
EXTERNAL %AddSY		( % S --> %+S )
EXTERNAL SYSub		( S1 S2 --> S1-S2 )
EXTERNAL SYSub%		( S % --> S-% )
EXTERNAL %SubSY		( % S --> %-S )
EXTERNAL SYMul		( S1 S2 --> S1*S2 )
EXTERNAL SYMul%		( S % --> S*% )
EXTERNAL SYDiv		( S1 S2 --> S1/S2 )
EXTERNAL SYDiv%		( S % --> S/% )
EXTERNAL %DivSY		( % S --> %/S )

EXTERNAL XNeg		( S --> -S )
EXTERNAL XAdd		( S1 S2 --> S )
EXTERNAL XSub		( S1 S2 --> S )
EXTERNAL XMul		( S1 S2 --> S )
EXTERNAL XDiv		( S1 S2 --> S )

** algroot

EXTERNAL QRoot		( Q #root --> Qint Qroot )
EXTERNAL ZSQRT		( Z --> Z' flag )

** algpf

EXTERNAL ParFrac	( symb {vars} --> symb' )
EXTERNAL PF2A		( Lpf Lvars --> symb )
EXTERNAL Frac2SS	( num den q pow --> sflag Meta )
EXTERNAL QParFrac	( Qn Qd #depth --> Lpf )
EXTERNAL QParFix	( Lpf --> Lpf' )
EXTERNAL PFDecomp	( pp qc qp lf --> Lpf )
EXTERNAL NoDecomp?	( pp qc qp lf --> pp qc qp lf flag )

** algmtrx

EXTERNAL MCKConst	( A --> A' )
EXTERNAL MCKRows	( A m --> A / Error )
EXTERNAL MCKSq		( A --> A / Error )
EXTERNAL MCKMat		( A --> A' / Error )
EXTERNAL MCKSame	( A B --> A' B' / Error )

EXTERNAL MDim		( A --> n m )
EXTERNAL MNorm		( A --> A' )
EXTERNAL MIdn		( #n --> In )
EXTERNAL MTrn		( A --> A' )

EXTERNAL MApp2		( A B f --> C=[f[aij,bij]] )
EXTERNAL MAdd		( A B --> C=A+B )
EXTERNAL MSub		( A B --> C=A-B )
EXTERNAL MNeg		( A --> -A )

EXTERNAL MDoDiagS	( A s f --> C )
EXTERNAL MAddS		( A x --> A+xI )
EXTERNAL MSubS		( A x --> A-xI )
EXTERNAL SSubM		( x A --> xI-A )

EXTERNAL MMulS		( A s --> s*A )
EXTERNAL MDivS		( A s --> A/s )
EXTERNAL MMul0		( A B --> A*B )
EXTERNAL MMul		( A B --> A*B )

EXTERNAL MPow#		( M # --> M^# )
EXTERNAL MPow%		( M % --> M^% )

EXTERNAL MLU		( M --> M' %rank )
EXTERNAL MInv		( A --> A^-1 )
EXTERNAL MDiv		( B A --> C=A^-1 * B )
EXTERNAL MDet		( A --> det[A] )

EXTERNAL MAvars		( MA --> Lvars )
EXTERNAL MAconcat	( M1 M2 --> M )

** algmmat

EXTERNAL MMsolve	( MM --> MM' )
EXTERNAL MMsolve2	( MM --> MM' )
EXTERNAL MMlurank	( MM --> MM' #rank )
EXTERNAL MMdet		( MM --> nom den )

EXTERNAL MMcrout	( MM --> MM' #rank [ & Error ] )
EXTERNAL BetterPivot?	( n1 d1 n2 d2 --> n1 d1 n2 d2 flag )
EXTERNAL MMsolvetri	( MM --> MM' )

EXTERNAL MA2MM		( MA Lvars --> MM )
EXTERNAL MM2MA		( MM ? Lvars --> ? MA )

EXTERNAL MMtrim		( MM ? --> MM' ? )
EXTERNAL MMnull		( #Y #X --> MM )
EXTERNAL MMdims		( MM ? --> MM #Y #X )
EXTERNAL MMdrop		( MM ? --> ? )
EXTERNAL MMsub		( MM ? #y1 #x1 #y2 #x2 --> ? MM' )
* EXTERNAL MMtrn	( MM ? --> MM' ? )
EXTERNAL MMrowswap	( MM ? #row1 #row2 --> MM' ? )
* EXTERNAL MMcolswap	( MM ? #col1 #col2 --> MM' ? )
EXTERNAL MMputcol	( MM ? Q #y #x --> MM' ? )
EXTERNAL MMgetR		( MM ? #stop+1 #start --> P Q )
EXTERNAL MMget		( MM ? #y #x --> MM ? nom den )
EXTERNAL MMput		( MM ? nom den #y #x --> MM' ? )

** algberle

EXTERNAL Berlekamp	( P --> P FALSE / P Lf #prime TRUE )

** algpfctr

EXTERNAL PFactor	( P --> Lf Z )
EXTERNAL PSqff		( P --> Lf )

EXTERNAL PHFctr		( P --> Lf )
EXTERNAL PHFctr1	( P --> Lf )
EXTERNAL PHFctr0	( P --> Lf )
EXTERNAL PNFctr		( Z --> Lf )

EXTERNAL PSQFF		( P --> Lsqff )
EXTERNAL DeCntMulti	( R --> L )
EXTERNAL DoLS		( L S F --> L' )
EXTERNAL LiftZAdic	( P z L --> Lf )
EXTERNAL LFCProd	( C F --> C P )

EXTERNAL UFactor	( P --> Lf )
EXTERNAL UFactor1	( P --> Lf )
EXTERNAL UFactorDeg2	( P --> Lf )
EXTERNAL MonicLf	( Lfp p --> Lfp' )
EXTERNAL DemonicLf	( Lfp lc p --> Lfp' )
EXTERNAL LiftLinear
EXTERNAL LiftGeneral
EXTERNAL CombineFac
EXTERNAL CombProd
EXTERNAL CombInit
EXTERNAL CombNext
EXTERNAL RmCombNext

EXTERNAL PFactTriv	( P --> P' Lf )
EXTERNAL PFactPowCnt	( P --> P Lk flag )
EXTERNAL PDivLk		( P Lk --> P' )
EXTERNAL VarFactor	( P #var --> P #pow )

** algrint

EXTERNAL QInt		( Q --> P Z )
EXTERNAL #Factorial	( #n --> Z )
EXTERNAL Horowitz	( q r --> R1 R2 L1 L2 )

EXTERNAL RatInt  	( sym var -> sym' )
EXTERNAL NotSafeInt?	( obj X -> flag )
EXTERNAL RNoInt		( sym num den q --> sym' )
EXTERNAL RQuadInt	( sym num d q --> sym' )
EXTERNAL RQILn		( sym --> sym' )
EXTERNAL RQIPos		( sym s1 s2 --> sym' )
EXTERNAL RQINeg		( sym s1 s2 --> sym' )
EXTERNAL RQIxSqrtv	( Meta --> Meta' )

** asim

EXTERNAL ASim		( Sym --> Sym' )
EXTERNAL ASimSym	( symb --> symb' )
EXTERNAL ASimMeta	( Meta --> Meta' )
EXTERNAL RSimMeta
EXTERNAL RFctrMeta
EXTERNAL SimpMeta1
EXTERNAL SimpMeta
EXTERNAL FctrMeta
EXTERNAL CommonFactor

EXTERNAL SimpOb
EXTERNAL Simp+
EXTERNAL Simp-
EXTERNAL Simp*
EXTERNAL Simp/
EXTERNAL SimpNeg
EXTERNAL SimpInv
EXTERNAL SimpSq
EXTERNAL SimpPow
EXTERNAL SimpPowN
*EXTERNAL SimpSqrt
EXTERNAL SimpExp
EXTERNAL SimpALog
*EXTERNAL SimpLn
*EXTERNAL SimpLog
*EXTERNAL SimpSin
*EXTERNAL SimpCos
*EXTERNAL SimpTan
*EXTERNAL SimpASin
*EXTERNAL SimpACos
*EXTERNAL SimpATan
*EXTERNAL SimpSinh
*EXTERNAL SimpCosh
*EXTERNAL SimpTanh
*EXTERNAL SimpASinh
*EXTERNAL SimpACosh
*EXTERNAL SimpATanh
*EXTERNAL SimpAbs
*EXTERNAL SimpRe
*EXTERNAL SimpIm
*EXTERNAL SimpConj

EXTERNAL TakeRoot	( %a %b --> Meta )
EXTERNAL FormRat?	( Meta --> Meta FALSE / %a %b TRUE )
EXTERNAL FormRoot?	( Meta --> Meta FALSE / %a %x %b TRUE )
EXTERNAL FormPi?

EXTERNAL MergeSym	( sym --> sym' )
EXTERNAL MergeMeta	( Meta --> Meta' )
EXTERNAL MergeInv
EXTERNAL Merge+
EXTERNAL Merge-
EXTERNAL Merge*
EXTERNAL Merge^
EXTERNAL Merge/
EXTERNAL Merge/Back
EXTERNAL MergeFix/
EXTERNAL Merge*Back
EXTERNAL MergeFix*
EXTERNAL MergeMult
*EXTERNAL MergeTrig
EXTERNAL Merge+Log
EXTERNAL Merge-Log
EXTERNAL Merge*Log
EXTERNAL Merge*Exp
EXTERNAL Merge^Exp
EXTERNAL Merge*Sqrt
EXTERNAL MergeTwice
EXTERNAL MergeTo*
EXTERNAL MergeTo/
EXTERNAL MergeTo+
EXTERNAL MergeTo-
EXTERNAL MergeProd
EXTERNAL MergeSum
EXTERNAL MergeReal
EXTERNAL ReSort

EXTERNAL EQops*
EXTERNAL EQops+
EXTERNAL EQops-
EXTERNAL shift<-A

EXTERNAL BothHaveFcn?
EXTERNAL HasFcn?
EXTERNAL BothHaveSame?
EXTERNAL Extract2
EXTERNAL Extract

**********************************************************************


